config/routes.rb
Everest::Application.routes.draw do
  resources :achievements

  resources :towers
  resources :sessions
  resources :users
  resources :climbs

  get "pages/index"

  get "register" => "users#new", :as => "register"
  get "login" => "users#login", :as => "login"
  get "logout" => "sessions#destroy"
  get "profile" => "users#profile"
  get "about" => "pages#about"

  match 'auth/:provider/callback', to: 'sessions#create_omniauth'
  match 'auth/failure', to: redirect('/')

  root :to => 'pages#index'

end

app/models/achievement.rb
class Achievement < ActiveRecord::Base
  attr_accessible :description, :name
end

app/controllers/achievements_controller.rb
class AchievementsController < ApplicationController
  # GET /achievements
  # GET /achievements.json
  def index
    @achievements = Achievement.all

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @achievements }
    end
  end

  # GET /achievements/1
  # GET /achievements/1.json
  def show
    @achievement = Achievement.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @achievement }
    end
  end

  # GET /achievements/new
  # GET /achievements/new.json
  def new
    @achievement = Achievement.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @achievement }
    end
  end

  # GET /achievements/1/edit
  def edit
    @achievement = Achievement.find(params[:id])
  end

  # POST /achievements
  # POST /achievements.json
  def create
    @achievement = Achievement.new(params[:achievement])

    respond_to do |format|
      if @achievement.save
        format.html { redirect_to @achievement, notice: 'Achievement was successfully created.' }
        format.json { render json: @achievement, status: :created, location: @achievement }
      else
        format.html { render action: "new" }
        format.json { render json: @achievement.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /achievements/1
  # PUT /achievements/1.json
  def update
    @achievement = Achievement.find(params[:id])

    respond_to do |format|
      if @achievement.update_attributes(params[:achievement])
        format.html { redirect_to @achievement, notice: 'Achievement was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @achievement.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /achievements/1
  # DELETE /achievements/1.json
  def destroy
    @achievement = Achievement.find(params[:id])
    @achievement.destroy

    respond_to do |format|
      format.html { redirect_to achievements_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/achievements_helper.rb
module AchievementsHelper
end

app/views/achievements/_form.html.erb
<%= form_for(@achievement) do |f| %>
  <% if @achievement.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@achievement.errors.count, "error") %> prohibited this achievement from being saved:</h2>

      <ul>
      <% @achievement.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br />
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :description %><br />
    <%= f.text_area :description %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/achievements/edit.html.erb
<h1>Editing achievement</h1>

<%= render 'form' %>

<%= link_to 'Show', @achievement %> |
<%= link_to 'Back', achievements_path %>

app/views/achievements/index.html.erb
<h1>Listing achievements</h1>

<table>
  <tr>
    <th>Name</th>
    <th>Description</th>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @achievements.each do |achievement| %>
  <tr>
    <td><%= achievement.name %></td>
    <td><%= achievement.description %></td>
    <td><%= link_to 'Show', achievement %></td>
    <td><%= link_to 'Edit', edit_achievement_path(achievement) %></td>
    <td><%= link_to 'Destroy', achievement, method: :delete, data: { confirm: 'Are you sure?' } %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'New Achievement', new_achievement_path %>

app/views/achievements/new.html.erb
<h1>New achievement</h1>

<%= render 'form' %>

<%= link_to 'Back', achievements_path %>

app/views/achievements/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <b>Name:</b>
  <%= @achievement.name %>
</p>

<p>
  <b>Description:</b>
  <%= @achievement.description %>
</p>


<%= link_to 'Edit', edit_achievement_path(@achievement) %> |
<%= link_to 'Back', achievements_path %>